package zero1hd.rhythmbullet.audio.visualizer;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.utils.Disposable;

import edu.emory.mathcs.jtransforms.fft.FloatFFT_1D;
import zero1hd.rhythmbullet.audio.MusicManager;

public class VisualizerCore implements Disposable {
	protected MusicManager mm;
	private FloatFFT_1D fft;
	float[] audioPCM;
	protected int width, height;
	protected int xPos, yPos;
	protected int barCount;
	
	public VisualizerCore(int width, int height, int x, int y) {
		this.height = height;
		this.width = width;
		this.xPos = x;
		this.yPos = y;
	}
	
	public void calculate() {
		if (mm != null) {
			mm.playbackIndexUpdate();
			if (mm.getPlaybackIndexPosition() > mm.getCurrentReadWindowIndex()) {
				while (mm.getPlaybackIndexPosition() > mm.getCurrentReadWindowIndex()) {
					mm.readSamples(audioPCM);
					fft.realForward(audioPCM);
				}
			}
		}
	}
	
	public void setMM(MusicManager mm) {
		this.mm = mm;
		fft = new FloatFFT_1D(mm.getReadWindowSize());
		audioPCM = new float[mm.getReadWindowSize()];
	}
	
	public void render(Batch batch, float parentAlpha) {
	}

	@Override
	public void dispose() {
	}
	
	public void setxPos(int xPos) {
		this.xPos = xPos;
	}
	
	public void setyPos(int yPos) {
		this.yPos = yPos;
	}
	
	public void setWidth(int width) {
		this.width = width;
	}
	
	public void setHeight(int height) {
		this.height = height;
	}
	
}
