package zero1hd.rhythmbullet.ui.components;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.ui.Widget;

import zero1hd.rhythmbullet.audio.MusicManager;
import zero1hd.rhythmbullet.audio.visualizer.BasicVisualizer;

public class Visualizer extends Widget {
	private BasicVisualizer vis;
	private Vector2 coords;
	private Vector2 size;
	
	public Visualizer() {
		vis = new BasicVisualizer();
		coords = new Vector2();
		size = new Vector2();
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		vis.render(batch, parentAlpha);
		super.draw(batch, parentAlpha);
	}
	
	@Override
	public void act(float delta) {
		vis.calculate();
		super.act(delta);
	}
	
	
	public void setMDP(MusicManager mdp) {
		vis.setMM(mdp);
	}
	
	@Override
	public void setX(float x) {
		coords.set(getX(), getY());
		getStage().stageToScreenCoordinates(coords);
		vis.setxPos((int) coords.x);
		super.setX(x);
	}
	
	@Override
	public void setY(float y) {
		coords.set(getX(), getY());
		getStage().stageToScreenCoordinates(coords);
		vis.setyPos((int) coords.y);
		super.setY(y);
	}
	
	@Override
	public void setWidth(float width) {
		size.set(getWidth(), getHeight());
		getStage().stageToScreenCoordinates(size);
		vis.setWidth((int) size.x);
		super.setWidth(width);
	}
	
	@Override
	public void setHeight(float height) {
		size.set(getWidth(), getHeight());
		getStage().stageToScreenCoordinates(size);
		vis.setWidth((int) size.y);
		super.setHeight(height);
	}
	
	@Override
	public void setSize(float width, float height) {
		setHeight(height);
		setWidth(width);
	}
	
	@Override
	public void setPosition(float x, float y) {
		setX(x);
		setY(y);
		super.setPosition(x, y);
	}
	
	@Override
	public void setRotation(float degrees) {
		vis.setRotation(degrees);
		super.setRotation(degrees);
	}
	
	@Override
	public void layout() {
		vis.updatePositionInfo();
		super.layout();
	}
}
